#include <stdio.h>

#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int main (int argc, char *argv[])
{
  struct hostent *host, *host_r;
  int i;
  char **aliases, **addresses;

  if (argc < 2)
    return -1;
  
  for (i = 1; i < argc; i++) {
    /* prelozime domenove jmeno na IP adresu */
    host = gethostbyname (argv[i]);

    if (!host) {
      perror ("gethostbyname error");
      return -1;
    }
    
    /* domenova jmena */
    printf ("Oficialni jmeno: %s\n", host->h_name);
    printf ("Alternativni jmena (aliasy): ");
    for (aliases = host->h_aliases; *aliases; aliases++) 
      printf ("%s ", *aliases);
    printf ("\n\n");
    
    /* IP adresy */
    printf ("IP adresy:\n");
    for (addresses = host->h_addr_list; *addresses; addresses++) {
      /* prelozime zpet IP adresu na domenove jmeno */
      host_r = gethostbyaddr (*addresses, 4, PF_INET);
      
      if (!host_r) {
	perror ("gethostbyaddr error");
	continue;
      }
      
      printf ("%s -> %s\n", inet_ntoa (*(struct in_addr *)*addresses),
	      host_r->h_name);
    }
    printf ("\n");
  }
  
  return 0;
}
