#include <stdio.h>
#include <string.h>
#include <signal.h>

#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <linux/if_ether.h>
#include <netinet/ether.h>

#define BUFSIZE 1500

int finish = 0;

void sig_handler (int sig)
{
  if (sig == SIGINT)
    finish = 1;
}

int main (int argc, char *argv[])
{
  struct sigaction act;
  
  int sock, i;
  ssize_t length;
  char buffer[BUFSIZE];
  struct sockaddr_ll address;
  socklen_t address_size;

  memset (&act, 0, sizeof(act));
  act.sa_handler = sig_handler;
  sigaction (SIGINT, &act, NULL);
  
  /* vytvorime packet socket */
  sock = socket (PF_PACKET, SOCK_RAW, htons (ETH_P_ALL));

  if (sock == -1) {
    perror ("socket error");
    return -1;
  }

  address_size = sizeof(address);
  
  while (!finish) {
    /* prijmeme data */
    length = recvfrom (sock, buffer, BUFSIZE, 0, (struct sockaddr *)&address,
		       &address_size);
    
    if (length == -1) {
      if (errno != EINTR) {
	perror ("recvfrom error");
	close (sock);
	return -1;
      }
      else
	continue;
    }
    
    /* vypiseme data */
    for (i = 0; i < length; i++)
      printf ("%02hhx ", buffer[i]);
    printf ("(%i bytes)\n", i);
  }
  
  /* zrusime socket */
  close (sock);
  
  return 0;
}
